require "thread"

class ActiveObject
  def initialize(obj)
    @obj = obj
    @mbox = Queue.new
    @meth = {}
    dispatch
  end

  def method_missing(meth, *arg, &block)
    res = Queue.new
    @mbox.push([meth, arg, block, res])
    res
  end

  def dispatch
    Thread.new do
      while true
	meth, arg, block, res = @mbox.pop
	res.push(@obj.send(meth, *arg, &block))
      end
    end
  end
end
def MakeActive(obj); ActiveObject.new(obj); end

class Foo
  def initialize(name)
    @name = name
  end

  def show
    sleep 1
    puts @name
  end
end

a = MakeActive(Foo.new("a"))
b = MakeActive(Foo.new("b"))

a.show
puts "waiting a"
b.show
puts "waiting b"

sleep 5
